package xyz.luxnk.mxmmod.cards;

import basemod.abstracts.CustomCard;
import com.megacrit.cardcrawl.actions.common.ApplyPowerAction;
import com.megacrit.cardcrawl.cards.AbstractCard;
import com.megacrit.cardcrawl.characters.AbstractPlayer;
import com.megacrit.cardcrawl.core.CardCrawlGame;
import com.megacrit.cardcrawl.dungeons.AbstractDungeon;
import com.megacrit.cardcrawl.localization.CardStrings;
import com.megacrit.cardcrawl.monsters.AbstractMonster;
import com.megacrit.cardcrawl.powers.DexterityPower;
import com.megacrit.cardcrawl.vfx.ThoughtBubble;
import xyz.luxnk.mxmmod.patches.AbstractCardEnum;
import xyz.luxnk.mxmmod.power.SpeedUpPower;

public class SeeThrough_MXM extends CustomCard {

    public static final String ID = "SeeThrough_MXM";
    private static final CardStrings cardStrings = CardCrawlGame.languagePack.getCardStrings(ID);
    public static final String NAME = cardStrings.NAME;
    public static final String DESCRIPTION = cardStrings.DESCRIPTION;
    public static final String IMG_PATH = "img/cards/skill/see_through.png";
    private static final int COST = 1;
    private static final int DEX_AMT = 2;
    private static final int UPGRADE_DEX_AMT = 2;
    private static final int SPEED_AMT = 1;

    public SeeThrough_MXM() {
        super(
                ID,
                NAME,
                IMG_PATH,
                COST,
                DESCRIPTION,
                CardType.SKILL,
                AbstractCardEnum.MXM_COLOR,
                CardRarity.UNCOMMON,
                CardTarget.SELF_AND_ENEMY
        );
        this.baseMagicNumber = DEX_AMT;
        this.magicNumber = this.baseMagicNumber;
    }

    @Override
    public void use(AbstractPlayer abstractPlayer, AbstractMonster abstractMonster) {

        if (abstractMonster.getIntentBaseDmg() >= 0) {
            AbstractDungeon.actionManager.addToBottom(
                    new ApplyPowerAction(
                            abstractPlayer,
                            abstractPlayer,
                            new DexterityPower(abstractPlayer, this.magicNumber),
                            this.magicNumber));
            AbstractDungeon.actionManager.addToBottom(
                    new ApplyPowerAction(
                            abstractPlayer,
                            abstractPlayer,
                            new SpeedUpPower(abstractPlayer, SPEED_AMT),
                            SPEED_AMT));
        } else {
            AbstractDungeon.effectList.add(new ThoughtBubble(AbstractDungeon.player.dialogX, AbstractDungeon.player.dialogY, 3.0F, TEXT[0], true));
        }
    }

    @Override
    public AbstractCard makeCopy() {
        return new SeeThrough_MXM();
    }

    @Override
    public void upgrade() {
        if (!this.upgraded) {
            upgradeName();
            upgradeMagicNumber(UPGRADE_DEX_AMT);
        }
    }
}
